package cn.ibizlab.businesscentral.core.odoo_account.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.odoo_account.domain.Account_cash_rounding;
import cn.ibizlab.businesscentral.core.odoo_account.filter.Account_cash_roundingSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[Account_cash_rounding] 服务对象接口
 */
public interface IAccount_cash_roundingService extends IService<Account_cash_rounding>{

    boolean create(Account_cash_rounding et) ;
    void createBatch(List<Account_cash_rounding> list) ;
    boolean update(Account_cash_rounding et) ;
    void updateBatch(List<Account_cash_rounding> list) ;
    boolean remove(Long key) ;
    void removeBatch(Collection<Long> idList) ;
    Account_cash_rounding get(Long key) ;
    Account_cash_rounding getDraft(Account_cash_rounding et) ;
    boolean checkKey(Account_cash_rounding et) ;
    boolean save(Account_cash_rounding et) ;
    void saveBatch(List<Account_cash_rounding> list) ;
    Page<Account_cash_rounding> searchDefault(Account_cash_roundingSearchContext context) ;
    List<Account_cash_rounding> selectByAccountId(Long id);
    void resetByAccountId(Long id);
    void resetByAccountId(Collection<Long> ids);
    void removeByAccountId(Long id);
    List<Account_cash_rounding> selectByCreateUid(Long id);
    void removeByCreateUid(Long id);
    List<Account_cash_rounding> selectByWriteUid(Long id);
    void removeByWriteUid(Long id);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<Account_cash_rounding> getAccountCashRoundingByIds(List<Long> ids) ;
    List<Account_cash_rounding> getAccountCashRoundingByEntities(List<Account_cash_rounding> entities) ;
}


